﻿using System;

class AverageMark
{
    static void Main()
    {
        float mark;
        float runningTotal;
        int count;

        // The do-while loop
        runningTotal = 0;
        count = 0;
        do
        {
            Console.Write("Enter your mark: ");
            mark = float.Parse(Console.ReadLine());
            runningTotal += mark;
            ++count;
        } while (count < 3);

        float average = runningTotal / count;
        Console.WriteLine($"do-while: Your average is {average:F1}%\n");

        // The while loop
        runningTotal = 0;
        count = 0;
        while (count < 3)
        {
            Console.Write("Enter your mark: ");
            mark = float.Parse(Console.ReadLine());

            // Curve all marks upwards by 10%
            mark = mark + mark * 0.10f;

            if (mark > 100)
            {
                Console.WriteLine("Capping your mark at 100%");
                mark = 100;
            }

            runningTotal += mark;
            ++count;
        }

        Console.WriteLine($"while: Your average is {runningTotal / count:F1}%\n");

        // The for loop
        runningTotal = 0;
        for (count = 0; count < 3; ++count)
        {
            Console.Write("Enter your mark: ");
            mark = float.Parse(Console.ReadLine());

            // Curve all marks upwards by 10%
            mark = mark + mark * 0.10f;

            if (mark > 100)
            {
                Console.WriteLine("Capping your mark at 100%");
                mark = 100;
            }

            runningTotal += mark;
        }

        Console.WriteLine($"for loop: Your average is {runningTotal / count:F1}%\n");

        // This time validate the marks
        runningTotal = 0;
        for (count = 0; count < 3; ++count)
        {
            do
            {
                Console.Write("Enter your mark: ");
                mark = float.Parse(Console.ReadLine());
                if (mark < 0 || mark > 100)
                {
                    Console.WriteLine("Error: mark out of range.");
                }
            } while (mark < 0 || mark > 100);

            // Curve all marks upwards by 10%
            mark = mark + mark * 0.10f;

            if (mark > 100)
            {
                Console.WriteLine("Capping your mark at 100%");
                mark = 100;
            }

            runningTotal += mark;
        }

        Console.WriteLine($"for loop with validation: Your average is {runningTotal / count:F1}%\n");
    }
}
